<div class="container">


    <div class="cards-container">
        <div class="row">
            <!-- To Do -->
            <div class="col">
                <mat-card class="task-info-card todo">
                    <mat-card-content>
                        <mat-card-title>To Do: {{ getStatusCount('To Do') }}</mat-card-title>
                    </mat-card-content>
                </mat-card>
            </div>
            <!-- In Progress -->
            <div class="col">
                <mat-card class="task-info-card in-progress">
                    <mat-card-content>
                        <mat-card-title>In Progress: {{ getStatusCount('In Progress') }}</mat-card-title>
                    </mat-card-content>
                </mat-card>
            </div>
            <!-- Done -->
            <div class="col">
                <mat-card class="task-info-card done">
                    <mat-card-content>
                        <mat-card-title>Done: {{ getStatusCount('Done') }}</mat-card-title>
                    </mat-card-content>
                </mat-card>
            </div>
        </div>
    </div>

    <div class="table-container">
        <mat-card>
            <mat-card-content>

                <div class="space-between">
                    <button (click)="addTask()" mat-raised-button color="accent">
                        <mat-icon>add</mat-icon>Create Task
                    </button>
    
                    <!-- Search Bar -->
                    <mat-form-field appearance="fill">
                        <mat-label>Search by Status</mat-label>
                        <input (keyup)="applyFilter(statusInput.value)" matInput #statusInput>
                    </mat-form-field>
                </div>
                

                <table matSort mat-table [dataSource]="dataSource" class="mat-elevation-z8">
                    <ng-container matColumnDef="title">
                        <th color="primary" mat-sort-header mat-header-cell *matHeaderCellDef> Title </th>
                        <td mat-cell *matCellDef="let task">{{ task.title }}</td>
                    </ng-container>

                    <ng-container matColumnDef="description">
                        <th color="primary" mat-sort-header mat-header-cell *matHeaderCellDef> Description </th>
                        <td mat-cell *matCellDef="let task">{{ task.description }}</td>
                    </ng-container>

                    <ng-container matColumnDef="status">
                        <th color="primary" mat-sort-header mat-header-cell *matHeaderCellDef> Status </th>
                        <td mat-cell *matCellDef="let task">{{ task.status }}</td>
                    </ng-container>

                    <ng-container matColumnDef="action">
                        <th mat-header-cell *matHeaderCellDef> Action </th>
                        <td mat-cell *matCellDef="let task">
                            <button (click)="editTask(task._id)" mat-icon-button color="primary" aria-label="Edit">
                                <mat-icon>edit</mat-icon>
                            </button>
                            <button (click)="viewTask(task._id)" mat-icon-button color="accent" aria-label="View">
                                <mat-icon>visibility</mat-icon>
                            </button>
                            <button (click)="deleteTask(task._id)" mat-icon-button color="warn" aria-label="Delete">
                                <mat-icon>delete</mat-icon>
                            </button>
                        </td>
                    </ng-container>

                    <tr mat-header-row *matHeaderRowDef="displayedColumns"></tr>
                    <tr mat-row *matRowDef="let task; columns: displayedColumns"></tr>
                </table>

            </mat-card-content>
            <br>
            <mat-card-footer>
                <mat-paginator [pageSizeOptions]="[5,10,20]" showFirstLastButtons></mat-paginator>
            </mat-card-footer>
        </mat-card>
    </div>

</div>